NAME
OpenAPI::Client::OpenAI::Path::completions - Documentation for the /completions path.
OPERATIONS
POST /completions
createCompletion
$client->create_completion({
body => { ... },
});
Creates a completion for the provided prompt and parameters.
Returns a completion object, or a sequence of completion objects if the request is streamed.
Request body
Content-Type: application/json
Example:
{
"choices" : [
{
"finish_reason" : "length",
"index" : 0,
"logprobs" : null,
"text" : "\n\nThis is indeed a test"
}
],
"created" : 1589478378,
"id" : "cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7",
"model" : "VAR_completion_model_id",
"object" : "text_completion",
"system_fingerprint" : "fp_44709d6fcb",
"usage" : {
"completion_tokens" : 7,
"prompt_tokens" : 5,
"total_tokens" : 12
}
}
Responses
200 - OK
Content-Type: application/json
Example:
{
"choices" : [
{
"finish_reason" : "length",
"index" : 0,
"logprobs" : null,
"text" : "\n\nThis is indeed a test"
}
],
"created" : 1589478378,
"id" : "cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7",
"model" : "VAR_completion_model_id",
"object" : "text_completion",
"system_fingerprint" : "fp_44709d6fcb",
"usage" : {
"completion_tokens" : 7,
"prompt_tokens" : 5,
"total_tokens" : 12
}
}
SCHEMAS
ChatCompletionStreamOptions
Options for streaming response. Only set this when you set stream: true .
CompletionUsage
Properties:
completion_tokens(integer, required) - Number of tokens in the generated completion.Default: 0
completion_tokens_details(object) - Breakdown of tokens used in a completion.prompt_tokens(integer, required) - Number of tokens in the prompt.Default: 0
prompt_tokens_details(object) - Breakdown of tokens used in the prompt.total_tokens(integer, required) - Total number of tokens used in the request (prompt + completion).Default: 0
CreateCompletionRequest
Properties:
best_of(integer) - Generatesbest_ofcompletions server-side and returns the "best" (the one with the highest log probability per token). Results cannot be streamed.When used with
n,best_ofcontrols the number of candidate completions andnspecifies how many to return –best_ofmust be greater thann.Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for
max_tokensandstop.Default: 1
echo(boolean) - Echo back the prompt in addition to the completionDefault:
frequency_penalty(number) - Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.See more information about frequency and presence penalties.
Default: 0
logit_bias(object) - Modify the likelihood of specified tokens appearing in the completion.Accepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. You can use this tokenizer tool to convert text to token IDs. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.
As an example, you can pass
{"50256": -100}to prevent the <|endoftext|> token from being generated.Default: null
logprobs(integer) - Include the log probabilities on thelogprobsmost likely output tokens, as well the chosen tokens. For example, iflogprobsis 5, the API will return a list of the 5 most likely tokens. The API will always return thelogprobof the sampled token, so there may be up tologprobs+1elements in the response.The maximum value for
logprobsis 5.Default: null
max_tokens(integer) - The maximum number of tokens that can be generated in the completion.The token count of your prompt plus
max_tokenscannot exceed the model's context length. Example Python code for counting tokens.Default: 16
model(anyOf, required) - ID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.n(integer) - How many completions to generate for each prompt.Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for
max_tokensandstop.Default: 1
presence_penalty(number) - Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.See more information about frequency and presence penalties.
Default: 0
prompt(oneOf, required) - The prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays.Note that <|endoftext|> is the document separator that the model sees during training, so if a prompt is not specified the model will generate as if from the beginning of a new document.
Default: <|endoftext|>
seed(integer) - If specified, our system will make a best effort to sample deterministically, such that repeated requests with the sameseedand parameters should return the same result.Determinism is not guaranteed, and you should refer to the
system_fingerprintresponse parameter to monitor changes in the backend.stop(StopConfiguration)See "StopConfiguration" below for shape.
stream(boolean) - Whether to stream back partial progress. If set, tokens will be sent as data-only server-sent events as they become available, with the stream terminated by adata: [DONE]message. Example Python code .Default:
stream_options(ChatCompletionStreamOptions)See "ChatCompletionStreamOptions" below for shape.
suffix(string) - The suffix that comes after a completion of inserted text.This parameter is only supported for
gpt-3.5-turbo-instruct.Default: null
temperature(number) - What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.We generally recommend altering this or
top_pbut not both.Default: 1
top_p(number) - An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.We generally recommend altering this or
temperaturebut not both.Default: 1
user(string) - A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more .
CreateCompletionResponse
Properties:
choices(array of object, required) - The list of completion choices the model generated for the input prompt.created(integer, required) - The Unix timestamp (in seconds) of when the completion was created.id(string, required) - A unique identifier for the completion.model(string, required) - The model used for completion.object(string, required) - The object type, which is always "text_completion"Allowed values: text_completion
system_fingerprint(string) - This fingerprint represents the backend configuration that the model runs with.Can be used in conjunction with the
seedrequest parameter to understand when backend changes have been made that might impact determinism.usage(CompletionUsage)See "CompletionUsage" below for shape.
StopConfiguration
Not supported with latest reasoning models o3 and o4-mini .
Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.
SEE ALSO
COPYRIGHT AND LICENSE
Copyright (C) 2023-2026 by Nelson Ferraz
This library is free software; you can redistribute it and/or modify it under the same terms as Perl itself, either Perl version 5.14.0 or, at your option, any later version of Perl 5 you may have available.